/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;

import java.util.Objects;

/**
 * MembershipRequest
 */

public class MembershipRequest {
  @JsonProperty("comment")
  private String comment = null;

  @JsonProperty("created")
  private LocalDateTime created = null;

  @JsonProperty("id")
  private String id = null;

  /**
   * The current request status
   */
  public enum StatusEnum {
    PENDING("pending"),
    
    ACCEPTED("accepted"),
    
    REFUSED("refused");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StatusEnum fromValue(String text) {
      for (StatusEnum b : StatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("status")
  private StatusEnum status = null;

  @JsonProperty("user")
  private UserReference user = null;

  public MembershipRequest comment(String comment) {
    this.comment = comment;
    return this;
  }

   /**
   * A request comment from the user
   * @return comment
  **/
  @ApiModelProperty(required = true, value = "A request comment from the user")
  public String getComment() {
    return comment;
  }

  public void setComment(String comment) {
    this.comment = comment;
  }

   /**
   * The request creation date
   * @return created
  **/
  @ApiModelProperty(value = "The request creation date")
  public LocalDateTime getCreated() {
    return created;
  }

   /**
   * Get id
   * @return id
  **/
  @ApiModelProperty(value = "")
  public String getId() {
    return id;
  }

  public MembershipRequest status(StatusEnum status) {
    this.status = status;
    return this;
  }

   /**
   * The current request status
   * @return status
  **/
  @ApiModelProperty(example = "pending", required = true, value = "The current request status")
  public StatusEnum getStatus() {
    return status;
  }

  public void setStatus(StatusEnum status) {
    this.status = status;
  }

  public MembershipRequest user(UserReference user) {
    this.user = user;
    return this;
  }

   /**
   * Get user
   * @return user
  **/
  @ApiModelProperty(value = "")
  public UserReference getUser() {
    return user;
  }

  public void setUser(UserReference user) {
    this.user = user;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    MembershipRequest membershipRequest = (MembershipRequest) o;
    return Objects.equals(this.comment, membershipRequest.comment) &&
        Objects.equals(this.created, membershipRequest.created) &&
        Objects.equals(this.id, membershipRequest.id) &&
        Objects.equals(this.status, membershipRequest.status) &&
        Objects.equals(this.user, membershipRequest.user);
  }

  @Override
  public int hashCode() {
    return Objects.hash(comment, created, id, status, user);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class MembershipRequest {\n");

    sb.append("    comment: ").append(toIndentedString(comment)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    user: ").append(toIndentedString(user)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

